import ru.ifmo.validate.*;

public class Validate implements Validator {
	static final int MAX_N = 10000;
	static final int MAX_M = 10000;
	static final int ALPHA = 90;
	static final int MAX_H = 1000;
	static final int MAX_X = 100000;
	static final int MAX_Y = 1000;

	@Override
	public void validate(ValidatingScanner in) throws Exception {
		int n = in.nextInt(1, MAX_N);
		int m = in.nextInt(2, MAX_M);
		int alpha = in.nextInt(1, ALPHA - 1);

		in.eoln();

		for (int i = 0; i < n; i++) {
			in.nextInt(1, MAX_H);
		}

		int last_x = -MAX_X;
		for (int i = 0; i < m; i++) {
			in.eoln();
			last_x = in.nextInt(last_x, MAX_X) + 1;
			in.nextInt(-MAX_Y, MAX_Y);
		}
	}
}
